const { fs } = require('./../bootstrap/modules');

function createService(serviceName, command) {
    let appName = command.options.app || APP_NAME;

    let serviceSegments = serviceName.split('/');

    let service = serviceSegments.end() + 'Service';

    let servicePath = ROOT + `/src/${appName}/components/services/${serviceName}-service.js`;

    if (fs.exists(servicePath)) {
        die(`${cli.redBright(serviceName)} service already exists!`);
    }

    echo(`${cli.yellow('Creating')} ${cli.green(serviceName)} service...`);

    // first we will copy the service
    fs.copy(FRAMEWORK_RESOURCES_PATH + '/service.js', servicePath);

    let serviceFileContent = fs.get(servicePath);

    let alias = command.options.alias || service.toCamelCase();

    let route = command.options.route || '/' + serviceName;

    serviceFileContent = serviceFileContent.replace('aliasName', alias)
                                           .replace('route', route)
                                           .replaceAll('ServiceName', service.toCamelCase().capitalize());

    fs.put(servicePath, serviceFileContent);

    echo(`${cli.cyan(serviceName)} ${cli.green('service has been created successfully.')}`);
}

module.exports = function (command) {
    if (command.services.length > 1 && command.route) {
        die(`Can't use ${cli.redBright('--route')} with more than one service`);
    }

    for (let serviceName of command.services) {
        createService(serviceName, command);
    }

    die();
}